<?php

namespace Drupal\monarch_auth_homepage;

use Drupal\Core\DependencyInjection\ContainerBuilder;
use Drupal\Core\DependencyInjection\ServiceModifierInterface;
use Drupal\Core\Path\PathMatcher as CorePathMatcher;
use Drupal\monarch_auth_homepage\Path\PathMatcher;
use Symfony\Component\DependencyInjection\Reference;

/**
 * Defines a service provider for the Monarch Auth Homepage module.
 */
final class MonarchAuthHomepageServiceProvider implements ServiceModifierInterface {

  /**
   * {@inheritdoc}
   */
  public function alter(ContainerBuilder $container): void {
    $path_matcher = $container->getDefinition('path.matcher');

    if ($path_matcher && $path_matcher->getClass() === CorePathMatcher::class) {
      $path_matcher->setClass(PathMatcher::class);
      $arguments = $path_matcher->getArguments();
      $arguments[] = new Reference('current_user');
      $path_matcher->setArguments($arguments);
    }
  }

}
